#include "lib/Compatibility.frag"

precision highp sampler2D;
precision highp usampler2D;

#define USE_MATERIAL_ID

#include "lib/Inputs.frag"
#include "lib/Materials.frag"
#include "lib/Slug.frag"

struct Material {
    lowp vec4 color;
    lowp vec4 effectColor;
};

Material decodeMaterial(uint matIndex) {
    {{decoder}}
    return mat;
}

in mediump vec4 fragColor;
in vec2 fragTextureCoords;
flat in vec4 fragBanding;
flat in ivec4 fragGlyph;

uniform sampler2D curveTexture;
uniform usampler2D bandTexture;

void main() {
    Material mat = decodeMaterial(fragMaterialId);
    vec4 color = mix(mat.effectColor, mat.color, fragColor.a)*vec4(fragColor.rgb, 1.0);
    outColor = SlugRender(curveTexture, bandTexture, fragTextureCoords,
        color, fragBanding, fragGlyph);
}
