/*
 * Set of functions you can re-use to work on colors.
 */

/**
 * @brief Create a gradient between four colors
 *
 * @param stop0 The color of the first stop point
 * @param stop1 The color of the second stop point
 * @param stop2 The color of the third stop point
 * @param stop3 The color of the fourth stop point
 *
 * This method assumes the stops are linear and spaced uniformly.
 */
mediump vec4 gradient4(mediump vec4 stop0, mediump vec4 stop1, mediump vec4 stop2, mediump vec4 stop3, highp float value) {
    highp float value2 = value * 2.0;
    vec4 a = mix(stop0, stop1, value2);
    vec4 b = mix(stop2, stop3, value2 - 1.0);
    return mix(a, b, smoothstep(0.495, 0.505, value));
}
